/*
 * @Author: hai.zhang
 * @LastEditors: hai.zhang
 * @Date: 2019-07-15 16:40:10
 * @LastEditTime: 2019-09-09 16:14:17
 */
const fs = require('fs')
const MiniCssExtractPlugin = require('mini-css-extract-plugin')
// 文件或目录是否存在
const exists = exports.exists = function (path) {
    return fs.existsSync(path)
}

// 是否是文件
exports.isFile = function (path) {
    return exists(path) && fs.statSync(path).isFile()
}

// 是否是目录
exports.isDir = function (path) {
    return exists(path) && fs.statSync(path).isDirectory()
}

exports.stlyeRules = function stlyeRules (sourceMap, extract, userConfig) {
    const types = [
      { test: /\.css$/, loader: 'css' },
      { test: /\.styl$/, loader: 'stylus' },
      { test: /\.less/, loader: 'less' },
      { test: /\.s[ac]ss$/, loader: 'sass' }]
    const options = { sourceMap: !!sourceMap }
    const use = [
      {
        loader: MiniCssExtractPlugin.loader,
        options: {}
      },
      {
        loader: 'css-loader',
        options: options
      },
      {
        loader: 'postcss-loader'
      }
    ]
    if (userConfig.device && userConfig.device === 'mobile') {
      use.push({
        loader: 'px2rem-loader',
        options: {
          remUnit: 75,
          remPrecision: 8
        }
      })
    }
  
    if (!extract) {
      use.unshift({
        loader: 'style-loader',
        options: options
      })
    }
  
    return types.map((t) => {
      const tuse = t.loader === 'css' ? use : use.concat({
        loader: t.loader + '-loader',
        options: options
      })
      console.log(tuse)
      // if (t.loader === 'sass' && userConfig.sassResources) {
      //   use.push({
      //     loader: 'sass-resources-loader',
      //     options: {
      //       // Or array of paths
      //       resources: userConfig.sassResources
      //     }
      //   })
      // }
      console.log(JSON.stringify(use))
      return extract ? {
        test: t.test,
        use: tuse
      } : {
        test: t.test,
        use: tuse
      }
    })
  }
  
  // exports.extractVueStlye = function extractVueStlye () {
  //   return {
  //     css: {
  //       use: [MiniCssExtractPlugin.loader, 'css-loader',{
  //         loader: 'px2rem-loader',
  //         options: {
  //           remPrecision: 2
  //         }
  //       }],
  //       fallback: 'vue-style-loader'
  //     },
  //     stylus: {
  //       fallback: "vue-style-loader",
  //       use: [MiniCssExtractPlugin.loader, 'css-loader', 'stylus-loader', {
  //         loader: 'px2rem-loader',
  //         options: {
  //           remPrecision: 2
  //         }
  //       }]
  //     },
  //     less: {
  //       fallback: "vue-style-loader",
  //       use: [MiniCssExtractPlugin.loader, 'css-loader', 'less-loader', {
  //         loader: 'px2rem-loader',
  //         options: {
  //           remPrecision: 2
  //         }
  //       }]
  //     },
  //     sass: {
  //       fallback: "vue-style-loader",
  //       use: [MiniCssExtractPlugin.loader, 'css-loader', 'sass-loader', {
  //         loader: 'px2rem-loader',
  //         options: {
  //           remPrecision: 2
  //         }
  //       }]
  //     },
  //     scss: {
  //       fallback: "vue-style-loader",
  //       use: [MiniCssExtractPlugin.loader, 'css-loader', 'sass-loader', {
  //         loader: 'px2rem-loader',
  //         options: {
  //           remPrecision: 2
  //         }
  //       }]
  //     }
  //   }
  // }
