#!/usr/bin/env node  
const program = require('commander')
const spawn = require('cross-spawn')
const path = require('path')
const package = require('../package.json')
let script;
program
    .version(package.version)
    .arguments('<script>')
    .action(function (name) {
        script = name;
    })
    .command('init [projectName]', '初始化项目')
    .option('-c', '--cover', '如果工程名称存在就覆盖掉')
    .command('dev', '开发')
    .command('build', '发布上线')
    .option('-r, --remove', 'build之前将dist目录删掉')
    .command('start', '开发自动启动服务')
    .parse(process.argv)

let args = process.argv.slice(3);

if (script === 'build') {
  const buildOptions = ['-a', '--all', '--remove', '-r']
  let i, pageName
  for (i = 0; i !== args.length; i++) {
    if (buildOptions.indexOf(args[i]) === -1) {
      pageName = args[i]
      break
    }
  }
  if (!pageName) {
    // 没传pageName
    args.unshift('')
  } else if (i !== 0) {
    // 如果传入了pageName，但不是第一个参数
    args.splice(i, 1)
    args.unshift(pageName)
  }
}

switch (script) {
    case 'init':
    case 'dev':
    case 'build':
    case 'start':
        const result = spawn.sync(
            'node',
            [require.resolve(path.join('../scripts', script))].concat(args),
            { stdio: 'inherit' }
        );
        process.exit(result.status);
        break;
    default:
        console.log('Run sy --help to see all options.')
        break;
}