/* https://github.com/sueddeutsche/chunk-rename-webpack-plugin */
let instanceCounter = 0

module.exports = class ChunkRenamePlugin {
  constructor (templates) {
    this.templates = templates;
    this.instanceId = `crwp-${instanceCounter++}`
  }

  apply (compiler) {
    compiler.plugin("this-compilation", (compilation) => {
      compilation.plugin(["optimize-chunks", "optimize-extracted-chunks"], (chunks) => {
        // Prevent multiple rename operations
        if (compilation[this.instanceId]) {
          return
        }
        compilation[this.instanceId] = true

        chunks.forEach((chunk) => {
          const parent = chunk.parents[0]

          if (parent && !chunk.name) {
            this.templates.forEach(tpl => {
              if (parent.name === tpl.chunk) {
                chunk.filenameTemplate = tpl.basePath + '/[name].[chunkhash:8].js'
              }
            })
          }
        })
      })
    })
  }
}